
//
// Author: Frantisek Vacek <fanda.vacek@volny.cz>, (C) 2007
//
// Copyright: See COPYING file that comes with this distribution
//

#ifndef QFSQLSTORAGEDRIVER_H
#define QFSQLSTORAGEDRIVER_H

#include <qfcoreglobal.h>
#include <qfsqlconnection.h>
#include <qfsqlquerybuilder.h>
#include <qfstoragedriver.h> 

class QFCORE_DECL_EXPORT QFReloadSqlRowException : public QFSqlException
{
	public:
		QFReloadSqlRowException(const QString& msg = QString()) : QFSqlException() { init("QFReloadSqlRowException", msg, QString()); }
};

//! TODO: write class documentation.
class QFCORE_DECL_EXPORT QFSqlStorageDriverProperties 
{
	public:
		typedef QMap<QString, QString> StringMap;
	protected:
		class Data : public QSharedData
		{
			public:
				QFSqlConnection connection;
				QFSqlQueryBuilder queryBuilder;
				QStringList tableIds; ///< list of tablenames in active query
				//int numRowsAffected;
				StringMap foreignKeyMap;
			public:
				Data(const QFSqlConnection &_connection = QFSqlConnection())
				: connection(_connection) {}
				~Data() { }
		};
		QSharedDataPointer<Data> d;
	protected:
		static const QFSqlStorageDriverProperties& sharedNull();
		QFSqlStorageDriverProperties(int);
	public:
		bool isNull() const {return d == sharedNull().d;}

		StringMap& foreignKeyMapRef() {return d->foreignKeyMap;}
		const StringMap& foreignKeyMap() const {return d->foreignKeyMap;}
		//int numRowsAffected() const {return d->numRowsAffected;}
		//void setNumRowsAffected(int n) {d->numRowsAffected = n;}
		QStringList tableIds() const {return d->tableIds;}
		QStringList& tableIdsRef() {return d->tableIds;}
		const QFSqlQueryBuilder& queryBuilder() const {return d->queryBuilder;}
		QFSqlQueryBuilder& queryBuilderRef() {return d->queryBuilder;}

		//! Looks if current connection has valid driver, if it has not, tries qfApp().connection(),
		//! if it has not a valid driver and throw_exc is true function throws exception.
		virtual const QFSqlConnection& connection(bool throw_exc = Qf::ThrowExc) const throw(QFException);
	public:
		QFSqlStorageDriverProperties();
		QFSqlStorageDriverProperties(const QFSqlConnection &_connection);
		virtual ~QFSqlStorageDriverProperties() {}
};
Q_DECLARE_METATYPE(QFSqlStorageDriverProperties);

//! TODO: write class documentation.
class QFCORE_DECL_EXPORT QFSqlStorageDriver : public QFStorageDriver
{
	public:
		static QFSqlStorageDriver storageDriver;
	protected:
		QFSqlStorageDriverProperties driverProperties(QFBasicTable::Row &row) const;
		//QFSqlConnection connection(QFBasicTable::Row & row) const;
		//void setNumRowsAffected(int n);
		//int numRowsAffected() const;
		QStringList tableIdsSortedAccordingToForeignKeys(QFBasicTable::Row & row);
		QFStringSet referencedForeignTables(QFBasicTable::Row & row);
	public:
		bool resultHasAllPriKeys(const QFSqlConnection &conn, const QFBasicTable::FieldList &fields, const QString &tableid);

		/// kdyz naklonuji radek, je treba vymazat minimalne autoincrement primarni klice.
		virtual void checkClonnedRow(QFBasicTable::Row &row) throw(QFException);
		virtual bool postRow(QFBasicTable::Row &row) throw(QFException);
		virtual bool deleteRow(QFBasicTable::Row &row) throw(QFException);
		//! Return number of reloaded rows, 1 or 0 if row was deleted by some one other.
		virtual int reloadRow(QFBasicTable::Row &row) throw(QFException);
		virtual void fillDefaultAndAutogeneratedValues(QFBasicTable::Row &row) throw(QFException);
	public:
		QFSqlStorageDriver() {}
		//virtual ~QFSqlStorageDriver();
};

#endif // QFSQLSTORAGEDRIVER_H

